package cn.com.infosec.util;

import java.security.Principal;
import java.security.PublicKey;
import java.security.cert.X509Certificate;

public class CertificateChainUtil {
   public static X509Certificate[] sortCertificates(X509Certificate[] certs) {
      int var1 = certs.length;
      int var2 = 0;

      boolean var3;
      int var4;
      Principal var10;
      while(true) {
         var3 = false;
         if (var2 >= var1) {
            break;
         }

         var10 = certs[var2].getSubjectDN();

         for(var4 = 0; var4 < var1 && !var10.equals(certs[var4].getIssuerDN()); ++var4) {
         }

         if (var4 == var1) {
            var3 = true;
            X509Certificate var10000 = certs[var2];
            break;
         }

         ++var2;
      }

      if (var2 == var1 && !var3) {
         throw new Exception("Can't found a usercert in the chain");
      } else {
         X509Certificate var6 = certs[0];
         certs[0] = certs[var2];
         certs[var2] = var6;
         Principal var7 = certs[0].getIssuerDN();
         byte var8 = 1;
         var10 = var7;

         for(var4 = var8; var4 < certs.length - 1; var4 = var2) {
            for(var1 = var4; var1 < certs.length; ++var1) {
               if (certs[var1].getSubjectDN().equals(var10)) {
                  X509Certificate var9 = certs[var4];
                  certs[var4] = certs[var1];
                  certs[var1] = var9;
                  var10 = certs[var4].getIssuerDN();
                  break;
               }
            }

            if (var1 == certs.length) {
               throw new Exception("Incomplete certificate chain in reply");
            }

            var2 = var4 + 1;
         }

         var1 = 0;

         while(var1 < certs.length - 1) {
            X509Certificate[] var12 = certs;
            int var10001 = var1;
            PublicKey var11 = certs[++var1].getPublicKey();

            try {
               var12[var10001].verify(var11);
            } catch (Exception var5) {
               throw new Exception("Certificate in chain does not verify");
            }
         }

         return certs;
      }
   }

   public static void main(String[] args) {
   }
}
